%--------------------------------------------------------------------------
% Function: [X;Y;Z] =>[x;y;z]
% Get chromaticity coordinate
%--------------------------------------------------------------------------
function xyz=GetChromCoord(XYZ)
%--------------------------------------------------------------------------
% clear all;
% XYZ=[0;1;0];
%--------------------------------------------------------------------------
A=abs(XYZ(1,:))<=1e-10 & abs(XYZ(2,:))<=1e-10 & abs(XYZ(3,:))<=1e-10;
B=[A;A;A];C=[~A;~A;~A];
XYZ=XYZ.*double(C)+double(B);
xyz(1,:)=XYZ(1,:)./(XYZ(1,:)+XYZ(2,:)+XYZ(3,:));
xyz(2,:)=XYZ(2,:)./(XYZ(1,:)+XYZ(2,:)+XYZ(3,:));
xyz(3,:)=XYZ(3,:)./(XYZ(1,:)+XYZ(2,:)+XYZ(3,:));
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
