%--------------------------------------------------------------------------
% Function: distance =>[xyz1,xyz2]
% Calculate xyz1,xyz2 distance on the chromaticity diagram
%--------------------------------------------------------------------------
function d=GetDistance(xyz1,xyz2)
%--------------------------------------------------------------------------
x1=xyz1(1,:);y1=xyz1(2,:);
x2=xyz2(1,:);y2=xyz2(2,:);
d=power(power(x1-x2,2)+power(y1-y2,2),1/2);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
