%--------------------------------------------------------------------------
% Get Crood by Color Temperature
% T from 2000K to 50000 K
%--------------------------------------------------------------------------
function [x,y,u,v,slope]=GetTcCoord(T)
%--------------------------------------------------------------------------
load('DataTable.mat','PlanckianLocusTemperature');
T=round(T);
x=PlanckianLocusTemperature.x(T-2000+1);
y=PlanckianLocusTemperature.y(T-2000+1);
u=PlanckianLocusTemperature.u(T-2000+1);
v=PlanckianLocusTemperature.v(T-2000+1);
slope=PlanckianLocusTemperature.slope(T-2000+1);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
