%-------------------------------------------------------------------------
% Bayer data convert Photo data
%-------------------------------------------------------------------------
function Photo=MatBayer2Photo(BayerColorData,BayerStruct)
%-------------------------------------------------------------------------
% clear all;
% load('cfadata.mat');
% [row,col,PhotoColor]=size(BayerColorData);

% X=[ 1,2,3,4,5,6,7,8;
%     8,7,6,5,4,3,2,1;
%     4,3,2,1,5,6,7,8;
%     1,3,5,7,8,6,4,2;
%     1,3,5,7,2,4,6,8;
%     8,6,4,2,7,5,3,1    ];
% [row,col]=size(X);
% BayerColorData=zeros(row,col,4);
% for n=1:4
%     BayerColorData(:,:,n)=X;
% end

[row,col,PhotoColor]=size(BayerColorData);
Photo=zeros(row*2,col*2,3);
T=zeros(row*2,col*2);
% load('rawdecode.mat','BayerStruct');
switch BayerStruct
    case 'rggb'         % 1-R, 2-G1, 3-G2, 4-B
        T=T*0;
        T(1:2:row*2,1:2:col*2)=BayerColorData(:,:,1);
        T(1:2:row*2,2:2:col*2-2)=(T(1:2:row*2,1:2:col*2-3)...
            +T(1:2:row*2,3:2:col*2-1))/2;
        T(2:2:row*2-2,1:2:col*2-1)=(T(1:2:row*2-3,1:2:col*2-1)...
            +T(3:2:row*2-1,1:2:col*2-1))/2;
        T(2:2:row*2-2,2:2:col*2-2)=(T(1:2:row*2-3,1:2:col*2-3)...
            +T(1:2:row*2-3,3:2:col*2-1)...
            +T(3:2:row*2-1,1:2:col*2-3)...
            +T(3:2:row*2-1,3:2:col*2-1))/4;
        T(:,col*2)=T(:,col*2-1);T(row*2,:)=T(row*2-1,:);
        Photo(:,:,1)=T;

        T=T*0;
        T(2:2:row*2,2:2:col*2)=BayerColorData(:,:,4);
        T(2:2:row*2,3:2:col*2-1)=(T(2:2:row*2,2:2:col*2-2)...
            +T(2:2:row*2,4:2:col*2))/2;
        T(3:2:row*2-1,2:2:col*2)=(T(2:2:row*2-2,2:2:col*2)...
            +T(4:2:row*2,2:2:col*2))/2;
        T(3:2:row*2-1,3:2:col*2-1)=(T(2:2:row*2-2,2:2:col*2-2)...
            +T(2:2:row*2-2,4:2:col*2)...
            +T(4:2:row*2,2:2:col*2-2)...
            +T(4:2:row*2,4:2:col*2))/4;
        T(:,1)=T(:,2);T(1,:)=T(2,:);
        Photo(:,:,3)=T;

        T=T*0;
        T(1:2:row*2,2:2:col*2)=BayerColorData(:,:,2);
        T(2:2:row*2,1:2:col*2)=BayerColorData(:,:,3);
        T(2:2:row*2-2,2:2:col*2-2)=(T(1:2:row*2-3,2:2:col*2-2)...
            +T(2:2:row*2-2,1:2:col*2-3)...
            +T(2:2:row*2-2,3:2:col*2-1)...
            +T(3:2:row*2-1,2:2:col*2-2))/4;
        T(3:2:row*2-1,3:2:col*2-1)=(T(2:2:row*2-2,3:2:col*2-1)...
            +T(3:2:row*2-1,2:2:col*2-2)...
            +T(3:2:row*2-1,4:2:col*2)...
            +T(4:2:row*2,3:2:col*2-1))/4;
        T(1,3:2:col*2-1)=(T(1,2:2:col*2-2)...
            +T(1,4:2:col*2)...
            +T(2,3:2:col*2-1))/3;
        T(row*2,2:2:col*2-2)=(T(row*2,1:2:col*2-3)...
            +T(row*2,3:2:col*2-1)...
            +T(row*2-1,2:2:col*2-2))/3;
        T(3:2:row*2-1,1)=(T(2:2:row*2-2,1)...
            +T(4:2:row*2,1)...
            +T(3:2:row*2-1,2))/3;
        T(2:2:row*2-2,col*2)=(T(1:2:row*2-3,col*2)...
            +T(3:2:row*2-1,col*2)...
            +T(2:2:row*2-2,col*2-1))/3;
        T(1,1)=(T(1,2)+T(2,1))/2;
        T(row*2,col*2)=(T(row*2,col*2-1)+T(row*2-1,col*2))/2;
        Photo(:,:,2)=T;
    case 'bggr'         % 1-B, 2-G1, 3-G2, 4-R
        T=T*0;
        T(1:2:row*2,1:2:col*2)=BayerColorData(:,:,4);
        T(1:2:row*2,2:2:col*2-2)=(T(1:2:row*2,1:2:col*2-3)...
            +T(1:2:row*2,3:2:col*2-1))/2;
        T(2:2:row*2-2,1:2:col*2-1)=(T(1:2:row*2-3,1:2:col*2-1)...
            +T(3:2:row*2-1,1:2:col*2-1))/2;
        T(2:2:row*2-2,2:2:col*2-2)=(T(1:2:row*2-3,1:2:col*2-3)...
            +T(1:2:row*2-3,3:2:col*2-1)...
            +T(3:2:row*2-1,1:2:col*2-3)...
            +T(3:2:row*2-1,3:2:col*2-1))/4;
        T(:,col*2)=T(:,col*2-1);T(row*2,:)=T(row*2-1,:);
        Photo(:,:,3)=T;

        T=T*0;
        T(2:2:row*2,2:2:col*2)=BayerColorData(:,:,1);
        T(2:2:row*2,3:2:col*2-1)=(T(2:2:row*2,2:2:col*2-2)...
            +T(2:2:row*2,4:2:col*2))/2;
        T(3:2:row*2-1,2:2:col*2)=(T(2:2:row*2-2,2:2:col*2)...
            +T(4:2:row*2,2:2:col*2))/2;
        T(3:2:row*2-1,3:2:col*2-1)=(T(2:2:row*2-2,2:2:col*2-2)...
            +T(2:2:row*2-2,4:2:col*2)...
            +T(4:2:row*2,2:2:col*2-2)...
            +T(4:2:row*2,4:2:col*2))/4;
        T(:,1)=T(:,2);T(1,:)=T(2,:);
        Photo(:,:,1)=T;

        T=T*0;
        T(1:2:row*2,2:2:col*2)=BayerColorData(:,:,2);
        T(2:2:row*2,1:2:col*2)=BayerColorData(:,:,3);
        T(2:2:row*2-2,2:2:col*2-2)=(T(1:2:row*2-3,2:2:col*2-2)...
            +T(2:2:row*2-2,1:2:col*2-3)...
            +T(2:2:row*2-2,3:2:col*2-1)...
            +T(3:2:row*2-1,2:2:col*2-2))/4;
        T(3:2:row*2-1,3:2:col*2-1)=(T(2:2:row*2-2,3:2:col*2-1)...
            +T(3:2:row*2-1,2:2:col*2-2)...
            +T(3:2:row*2-1,4:2:col*2)...
            +T(4:2:row*2,3:2:col*2-1))/4;
        T(1,3:2:col*2-1)=(T(1,2:2:col*2-2)...
            +T(1,4:2:col*2)...
            +T(2,3:2:col*2-1))/3;
        T(row*2,2:2:col*2-2)=(T(row*2,1:2:col*2-3)...
            +T(row*2,3:2:col*2-1)...
            +T(row*2-1,2:2:col*2-2))/3;
        T(3:2:row*2-1,1)=(T(2:2:row*2-2,1)...
            +T(4:2:row*2,1)...
            +T(3:2:row*2-1,2))/3;
        T(2:2:row*2-2,col*2)=(T(1:2:row*2-3,col*2)...
            +T(3:2:row*2-1,col*2)...
            +T(2:2:row*2-2,col*2-1))/3;
        T(1,1)=(T(1,2)+T(2,1))/2;
        T(row*2,col*2)=(T(row*2,col*2-1)+T(row*2-1,col*2))/2;
        Photo(:,:,2)=T;
    case 'grbg'         % 1-G1, 2-R, 3-B, 4-G2
        T=T*0;
        T(1:2:row*2,2:2:col*2)=BayerColorData(:,:,1);
        T(1:2:row*2,3:2:col*2-1)=(T(1:2:row*2,2:2:col*2-2)...
            +T(1:2:row*2,4:2:col*2))/2;
        T(2:2:row*2-2,2:2:col*2)=(T(1:2:row*2-3,2:2:col*2)...
            +T(3:2:row*2-1,2:2:col*2))/2;
        T(2:2:row*2-2,3:2:col*2-1)=(T(1:2:row*2-3,2:2:col*2-2)...
            +T(1:2:row*2-3,4:2:col*2)...
            +T(3:2:row*2-1,2:2:col*2-2)...
            +T(3:2:row*2-1,4:2:col*2))/4;
        T(:,1)=T(:,2);T(row*2,:)=T(row*2-1,:);
        Photo(:,:,1)=T;

        T=T*0;
        T(2:2:row*2,1:2:col*2-1)=BayerColorData(:,:,4);
        T(2:2:row*2,2:2:col*2-2)=(T(2:2:row*2,1:2:col*2-3)...
            +T(2:2:row*2,3:2:col*2-1))/2;
        T(3:2:row*2-1,1:2:col*2-1)=(T(2:2:row*2-2,1:2:col*2-1)...
            +T(4:2:row*2,1:2:col*2-1))/2;
        T(3:2:row*2-1,2:2:col*2-2)=(T(2:2:row*2-2,1:2:col*2-3)...
            +T(2:2:row*2-2,3:2:col*2-1)...
            +T(4:2:row*2,1:2:col*2-3)...
            +T(4:2:row*2,3:2:col*2-1))/4;
        T(:,col*2)=T(:,col*2-1);T(1,:)=T(2,:);
        Photo(:,:,3)=T;

        T=T*0;
        T(1:2:row*2-1,1:2:col*2-1)=BayerColorData(:,:,2);
        T(2:2:row*2,2:2:col*2)=BayerColorData(:,:,3);
        T(2:2:row*2-2,3:2:col*2-1)=(T(1:2:row*2-3,3:2:col*2-1)...
            +T(2:2:row*2-2,2:2:col*2-2)...
            +T(2:2:row*2-2,4:2:col*2)...
            +T(3:2:row*2-1,3:2:col*2-1))/4;
        T(3:2:row*2-1,2:2:col*2-2)=(T(2:2:row*2-2,2:2:col*2-2)...
            +T(3:2:row*2-1,1:2:col*2-3)...
            +T(3:2:row*2-1,3:2:col*2-1)...
            +T(4:2:row*2,2:2:col*2-2))/4;
        T(1,2:2:col*2-2)=(T(1,1:2:col*2-3)...
            +T(1,3:2:col*2-1)...
            +T(2,2:2:col*2-2))/3;
        T(row*2,3:2:col*2-1)=(T(row*2,2:2:col*2-2)...
            +T(row*2,4:2:col*2)...
            +T(row*2-1,3:2:col*2-1))/3;
        T(2:2:row*2-2,1)=(T(1:2:row*2-3,1)...
            +T(3:2:row*2-1,1)...
            +T(2:2:row*2-2,2))/3;
        T(3:2:row*2-1,col*2)=(T(2:2:row*2-2,col*2)...
            +T(4:2:row*2,col*2)...
            +T(3:2:row*2-1,col*2-1))/3;
        T(1,col*2)=(T(1,col*2-1)+T(2,col*2))/2;
        T(row*2,1)=(T(row*2-1,1)+T(row*2,2))/2;
        Photo(:,:,2)=T;
    otherwise %'GBRG'       % 1-G1, 2-B, 3-R, 4-G2
        T=T*0;
        T(1:2:row*2,2:2:col*2)=BayerColorData(:,:,4);
        T(1:2:row*2,3:2:col*2-1)=(T(1:2:row*2,2:2:col*2-2)...
            +T(1:2:row*2,4:2:col*2))/2;
        T(2:2:row*2-2,2:2:col*2)=(T(1:2:row*2-3,2:2:col*2)...
            +T(3:2:row*2-1,2:2:col*2))/2;
        T(2:2:row*2-2,3:2:col*2-1)=(T(1:2:row*2-3,2:2:col*2-2)...
            +T(1:2:row*2-3,4:2:col*2)...
            +T(3:2:row*2-1,2:2:col*2-2)...
            +T(3:2:row*2-1,4:2:col*2))/4;
        T(:,1)=T(:,2);T(row*2,:)=T(row*2-1,:);
        Photo(:,:,3)=T;

        T=T*0;
        T(2:2:row*2,1:2:col*2-1)=BayerColorData(:,:,1);
        T(2:2:row*2,2:2:col*2-2)=(T(2:2:row*2,1:2:col*2-3)...
            +T(2:2:row*2,3:2:col*2-1))/2;
        T(3:2:row*2-1,1:2:col*2-1)=(T(2:2:row*2-2,1:2:col*2-1)...
            +T(4:2:row*2,1:2:col*2-1))/2;
        T(3:2:row*2-1,2:2:col*2-2)=(T(2:2:row*2-2,1:2:col*2-3)...
            +T(2:2:row*2-2,3:2:col*2-1)...
            +T(4:2:row*2,1:2:col*2-3)...
            +T(4:2:row*2,3:2:col*2-1))/4;
        T(:,col*2)=T(:,col*2-1);T(1,:)=T(2,:);
        Photo(:,:,1)=T;

        T=T*0;
        T(1:2:row*2-1,1:2:col*2-1)=BayerColorData(:,:,2);
        T(2:2:row*2,2:2:col*2)=BayerColorData(:,:,3);
        T(2:2:row*2-2,3:2:col*2-1)=(T(1:2:row*2-3,3:2:col*2-1)...
            +T(2:2:row*2-2,2:2:col*2-2)...
            +T(2:2:row*2-2,4:2:col*2)...
            +T(3:2:row*2-1,3:2:col*2-1))/4;
        T(3:2:row*2-1,2:2:col*2-2)=(T(2:2:row*2-2,2:2:col*2-2)...
            +T(3:2:row*2-1,1:2:col*2-3)...
            +T(3:2:row*2-1,3:2:col*2-1)...
            +T(4:2:row*2,2:2:col*2-2))/4;
        T(1,2:2:col*2-2)=(T(1,1:2:col*2-3)...
            +T(1,3:2:col*2-1)...
            +T(2,2:2:col*2-2))/3;
        T(row*2,3:2:col*2-1)=(T(row*2,2:2:col*2-2)...
            +T(row*2,4:2:col*2)...
            +T(row*2-1,3:2:col*2-1))/3;
        T(2:2:row*2-2,1)=(T(1:2:row*2-3,1)...
            +T(3:2:row*2-1,1)...
            +T(2:2:row*2-2,2))/3;
        T(3:2:row*2-1,col*2)=(T(2:2:row*2-2,col*2)...
            +T(4:2:row*2,col*2)...
            +T(3:2:row*2-1,col*2-1))/3;
        T(1,col*2)=(T(1,col*2-1)+T(2,col*2))/2;
        T(row*2,1)=(T(row*2-1,1)+T(row*2,2))/2;
        Photo(:,:,2)=T;
end
% Photo=uint16(Photo);
% imwrite(Photo,'D:\Photo TIFF\XXX.TIF','tiff');
%-------------------------------------------------------------------------
end
%-------------------------------------------------------------------------
