%--------------------------------------------------------------------------
% Highlight Expand when R,G,B overflow, forecast R,G,B Value
%--------------------------------------------------------------------------
function ImageRaw=MatHighlightExpand(ImageRaw,CameraNeutral)
%--------------------------------------------------------------------------
% clear all;
% load('ImageRawCamera.mat','ImageRawCamera');
% load('rawdecode.mat','CameraNeutral');
% CameraNeutral=[0.5356;1;0.5845];
% ImageRawCamera=[...
%     0.5356,0.0000,0.0000,0.4,1.0,0.3,0.4,0.4,0.6,0.6,0.6,1.0,1.0;...
%     0.0000,1.0000,0.0000,0.4,0.4,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0;...
%     0.0000,0.0000,0.5845,0.4,1.0,0.4,0.7,1.0,0.5,0.7,1.0,0.8,1.0];
%--------------------------------------------------------------------------
disp('-------- Highlight Expand --------');
% PhotoHist(ImageRawCamera,1600,2150,18000,18000,1);
[MaxRgb,Index]=sort(CameraNeutral);
C1=ImageRaw(Index(1),:);
C2=ImageRaw(Index(2),:);
C3=ImageRaw(Index(3),:);
clear ImageRawCamera;
Rmax=MaxRgb(1);Gmax=MaxRgb(3);Bmax=MaxRgb(2);
maxRGB=[Rmax;Gmax;Bmax];
% MaxValue=0.9985;
MaxValue=0.90;
mask=C1<Rmax & C2<Bmax;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'Undo',maxRGB);
Re=Rt.*double(mask);Ge=Gt.*double(mask);Be=Bt.*double(mask);
disp('6');
mask=C1<Rmax & C2>=Bmax & C2<MaxValue;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'Blue',maxRGB);
Re=Re+Rt.*double(mask);Ge=Ge+Gt.*double(mask);Be=Be+Bt.*double(mask);
mask=C1<Rmax & C2>=MaxValue;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'BlueClipping',maxRGB);
Re=Re+Rt.*double(mask);Ge=Ge+Gt.*double(mask);Be=Be+Bt.*double(mask);
disp('5');
mask=C1>=Rmax & C1<MaxValue & C2<Bmax;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'Red',maxRGB);
Re=Re+Rt.*double(mask);Ge=Ge+Gt.*double(mask);Be=Be+Bt.*double(mask);
mask=C1>=Rmax & C1<MaxValue & C2>=Bmax & C2<MaxValue;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'More',maxRGB);
Re=Re+Rt.*double(mask);Ge=Ge+Gt.*double(mask);Be=Be+Bt.*double(mask);
disp('4');
mask=C1>=Rmax & C1<MaxValue & C2>=MaxValue;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'BlueClipping',maxRGB);
Re=Re+Rt.*double(mask);Ge=Ge+Gt.*double(mask);Be=Be+Bt.*double(mask);
mask=C1>=MaxValue & C2<Bmax;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'Red',maxRGB);
Re=Re+Rt.*double(mask);Ge=Ge+Gt.*double(mask);Be=Be+Bt.*double(mask);
disp('3');
mask=C1>=MaxValue & C2>=Bmax & C2<MaxValue;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'RedClipping',maxRGB);
Re=Re+Rt.*double(mask);Ge=Ge+Gt.*double(mask);Be=Be+Bt.*double(mask);
disp('2');
mask=C1>=MaxValue & C2>=MaxValue;
[Rt,Gt,Bt]=GetForecastColor(C1,C3,C2,'Clipping',maxRGB);
Re=Re+Rt.*double(mask);Ge=Ge+Gt.*double(mask);Be=Be+Bt.*double(mask);
clear mask;clear Rt;clear Gt;clear Bt;
disp('1');
ImageRaw(Index(1),:)=C1.*double(MaxValue>C3)+Re.*double(MaxValue<=C3);
clear Re;clear C1;
ImageRaw(Index(2),:)=C2.*double(MaxValue>C3)+Be.*double(MaxValue<=C3);
clear Be;clear C2;
ImageRaw(Index(3),:)=C3.*double(MaxValue>C3)+Ge.*double(MaxValue<=C3);
clear Ge;clear C3;
disp('0');
% PhotoHist(ImageRawCamera,1600,2150,18000,18000,4);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
