%--------------------------------------------------------------------------
% H,U,V => ProPoto R,G,B 
% ImageHsv(:,:,3) H-1,S-2,V-3 => ImageRgb(:,:,3) R-1,G-2,B-3
%--------------------------------------------------------------------------
function ImageRgb=MatHsv2Rgb(ImageHsv)
%--------------------------------------------------------------------------
H=ImageHsv(1,:);S=ImageHsv(2,:);V=ImageHsv(3,:);
clear ImageHsv;
H=mod(H,360);S=max(S,0);S=min(S,1.0);V=max(V,0);V=min(V,1.0);
C=V.*S;clear S;
X=C.*(1-abs(mod(H/60,2)-1));
ImageRgb(1,:)=C.*double(H/60>=0&H/60<1)+X.*double(H/60>=1&H/60<2)...
    +0.0*double(H/60>=2&H/60<3)+0.0*double(H/60>=3&H/60<4)...
    +X.*double(H/60>=4&H/60<5)+C.*double(H/60>=5&H/60<6)+V-C;
ImageRgb(2,:)=X.*double(H/60>=0&H/60<1)+C.*double(H/60>=1&H/60<2)...
    +C.*double(H/60>=2&H/60<3)+X.*double(H/60>=3&H/60<4)...
    +0.0*double(H/60>=4&H/60<5)+0.0*double(H/60>=5&H/60<6)+V-C;
ImageRgb(3,:)=0.0*double(H/60>=0&H/60<1)+0.0*double(H/60>=1&H/60<2)...
    +X.*double(H/60>=2&H/60<3)+C.*double(H/60>=3&H/60<4)...
    +C.*double(H/60>=4&H/60<5)+X.*double(H/60>=5&H/60<6)+V-C;
clear C;clear V;clear X;clear H;
ImageRgb=max(ImageRgb,0);ImageRgb=min(ImageRgb,1.0);
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
