%--------------------------------------------------------------------------
% Constrast processing
% Constrast: K=1, no change, K>1, increase, K<1 decrease
function ImageRgb=RawConstrast(ImageRgb,Constrast,WorkColorSpace)
%--------------------------------------------------------------------------
ImageRgb=min(ImageRgb,1.0);ImageRgb=max(ImageRgb,0);

ImageXyz=RawSpaceRgb2Xyz(ImageRgb,WorkColorSpace);

ImageLab=MatXyz2Lab(ImageXyz);
ImageLab(1,:)=(ImageLab(1,:)-50)*Constrast+50;
ImageLab(1,:)=min(ImageLab(1,:),100.0);
ImageLab(1,:)=max(ImageLab(1,:),0);
ImageXyz=MatLab2Xyz(ImageLab);

ImageRgb=RawSpaceXyz2Rgb(ImageXyz,WorkColorSpace);

ImageRgb=min(ImageRgb,1.0);ImageRgb=max(ImageRgb,0);
%MidLight=0.18;  % 18% grey
%ImageRgb=Constrast*(ImageRgb-MidLight)+MidLight;
%------------------------ if rsConstrastBrightness ------------------------
end
%--------------------------------------------------------------------------

