%--------------------------------------------------------------------------
% Baseline Exposure Calibration
%--------------------------------------------------------------------------
function ImageRgb=RawExposureCalibration(ImageRgb)
%--------------------------------------------------------------------------
load('rawcamera.mat','Camera');
ExposureCalibration=0;
if isfield(Camera,'BaselineExposure')
    ExposureCalibration=ExposureCalibration+Camera.BaselineExposure;
end
if isfield(Camera,'BaselineExposureOffset')
    ExposureCalibration=ExposureCalibration+Camera.BaselineExposureOffset;
end
ImageRgb=ImageRgb*2^ExposureCalibration;
save('rawdecode.mat','ExposureCalibration','-append');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
