%--------------------------------------------------------------------------
% Function: Camera color space to CIE XYZ
% ImageRgb(3,:) => ImageXyz(3,:)
%--------------------------------------------------------------------------
function [XyzNeutral,ImageXyzRaw]=RawSpaceCameraToXyz(...
    ImageRawCamera,CameraNeutral)
%--------------------------------------------------------------------------
ApexRgb=[CameraNeutral(1),0,0,CameraNeutral(1);...
        0,CameraNeutral(2),0,0;0,0,CameraNeutral(3),0];
%--------------------------------------------------------------------------
% for n=1:3
%     ImageRawCamera(n,:)=min(ImageRawCamera(n,:),CameraNeutral(n));
%     ApexRgb(n,:)=min(ApexRgb(n,:),CameraNeutral(n));
% end
%--------------------------------------------------------------------------
[XyzNeutral,CameraToXYZ]=MatCameraToXYZ(CameraNeutral);
ImageXyzRaw=CameraToXYZ*ImageRawCamera;
clear ImageRawCamera;
save('rawdecode.mat','CameraToXYZ','CameraNeutral','XyzNeutral','-append');
%--------------------------------------------------------------------------
ApexXyz=CameraToXYZ*ApexRgb;
Apex.val=ApexXyz;Apex.color=[1,0,0];Apex.point='o';Apex.style=0;
MatXyzChromDiagram(ImageXyzRaw,Apex,'ImageXyzRaw');
save('rawapex.mat','ApexRgb','ApexXyz','Apex');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
