%--------------------------------------------------------------------------
% Save Tiff Photograph 
% ImageData(3,:) => PhotoTiff(:,:,3) and Save '.tif' photo file
%--------------------------------------------------------------------------
function RawTiffPhoto(ImageRgb,FilePathName)
%--------------------------------------------------------------------------
load('rawconfig.mat','TiffShow','TiffSave','FigSequence');
load('rawdecode.mat','PhotoWidth','PhotoHeight');
% PhotoTiff=zeros(PhotoHeight,PhotoWidth,3);
% for n=1:3
%     PhotoTiff(:,:,n)=reshape(ImageRgb(n,:),PhotoWidth,PhotoHeight)';
% end
PhotoTiff=MatImage2Photo(ImageRgb,PhotoHeight,PhotoWidth);
PhotoTiff=uint16(PhotoTiff*(2^16-1));
if TiffShow==1
    figure(FigSequence);
    FigSequence=FigSequence+1;
    image(PhotoTiff);
end
if TiffSave==1
    imwrite(PhotoTiff,strcat(FilePathName,'.tif'),'tif');
    save('rawconfig.mat','FigSequence','-append');
    disp('-------- Save Tiff Photo -----------')
else
    disp('-------- Tiff Photo Not Saved -----------')
end
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
