%--------------------------------------------------------------------------
% Function: [X;Y;Z] To [Xw;Yw;Zw] => Madapt Matrix
% The linear Bradford algorithm, get color adapt matrix
%--------------------------------------------------------------------------
function Madapt=MatBradfordAlgorithm(XYZ,XYZw)
%--------------------------------------------------------------------------
% Mbfd=[  0.8951,  0.2664, -0.1614;...
%        -0.7502,  1.7135,  0.0367;...
%         0.0389, -0.0685,  1.0296    ] ;
% Mbfd=[  0.8562,  0.3372, -0.1934;...
%        -0.8360,  1.8327,  0.0033;...
%         0.0357, -0.0469,  1.0112    ];
Mbfd=[  0.7328,  0.4296, -0.1624;...
       -0.7036,  1.6975,  0.0061;...
        0.0030,  0.0136,  0.9834    ];
SRC=Mbfd*XYZ;
PCS=Mbfd*XYZw;
T=[ PCS(1)/SRC(1),      0,              0; ...
        0,          PCS(2)/SRC(2),      0; ...
        0,              0,          PCS(3)/SRC(3)    ];
Madapt=Mbfd\T*Mbfd;
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
