%--------------------------------------------------------------------------
function MatCameraInfo(Info)
%--------------------------------------------------------------------------
load('rawcamera.mat','Camera');
FieldInfo=fieldnames(Info);
for n=1:length(FieldInfo)
    fieldstring=cell2mat(FieldInfo(n));
    if strcmp(fieldstring,'ActiveArea')
        Camera.ActiveArea=getfield(Info,fieldstring);
    elseif strcmp(FieldInfo(n),'AliasLayerMetadata')
        Camera.AliasLayerMetadata=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'AnalogBalance')
        Camera.AnalogBalance=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'AntiAliasStrength')
        Camera.AntiAliasStrength=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Artist')
        Camera.Artist=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'AsShotNeutral')
        Camera.AsShotNeutral=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BaselineExposure')
        Camera.BaselineExposure=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BaselineNoise')
        Camera.BaselineNoise=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BaselineSharpness')
        Camera.BaselineSharpness=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BayerGreenSplit')
        Camera.BayerGreenSplit=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BestQualityScale')
        Camera.BestQualityScale=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BitDepth')
        Camera.BitDepth=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BitsPerSample')
        Camera.BitsPerSample=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BlackLevel')
        Camera.BlackLevel=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BlackLevelDeltaH')
        Camera.BlackLevelDeltaH=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BlackLevelDeltaV')
        Camera.BlackLevelDeltaV=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'BlackLevelRepeatDim')
        Camera.BlackLevelRepeatDim=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'ByteOrder')
        Camera.ByteOrder=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'CFALayout')
        Camera.CFALayout=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'CFAPlaneColor')
        Camera.CFAPlaneColor=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'CalibrationIlluminant1')
        Camera.CalibrationIlluminant1=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'CalibrationIlluminant2')
        Camera.CalibrationIlluminant2=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'CameraCalibration1')
        Camera.CameraCalibration1=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'CameraCalibration2')
        Camera.CameraCalibration2=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'CameraSerialNumber')
        Camera.CameraSerialNumber=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'ColorMatrix1')
        Camera.ColorMatrix1=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'ColorMatrix2')
        Camera.ColorMatrix2=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'ColorType')
        Camera.ColorType=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Colormap')
        Camera.Colormap=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Compression')
        Camera.Compression=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'DNGBackwardVersion')
        Camera.DNGBackwardVersion=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'DNGPrivateData')
        Camera.DNGPrivateData=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'DNGVersion')
        Camera.DNGVersion=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'DateTime')
        Camera.DateTime=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'DefaultCropOrigin')
        Camera.DefaultCropOrigin=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'DefaultCropSize')
        Camera.DefaultCropSize=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'DefaultScale')
        Camera.DefaultScale=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'DigitalCamera')
        Camera.DigitalCamera=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'FileModDate')
        Camera.FileModDate=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'FileSize')
        Camera.FileSize=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Filename')
        Camera.Filename=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'FillOrder')
        Camera.FillOrder=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Format')
        Camera.Format=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'FormatSignature')
        Camera.FormatSignature=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'FormatVersion')
        Camera.FormatVersion=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'GPSInfo')
        Camera.GPSInfo=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'GrayResponseUnit')
        Camera.GrayResponseUnit=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Height')
        Camera.Height=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'ImageDescription')
        Camera.ImageDescription=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'LensInfo')
        Camera.LensInfo=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'LinearResponseUnit')
        Camera.LinearResponseUnit=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'LinearizationTable')
        Camera.LinearizationTable=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Make')
        Camera.Make=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'MaskedAreas')
        Camera.MaskedAreas=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'MaxSampleValue')
        Camera.MaxSampleValue=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'MinSampleValue')
        Camera.MinSampleValue=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Model')
        Camera.Model=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'NewSubFileType')
        Camera.NewSubFileType=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Offset')
        Camera.Offset=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Orientation')
        Camera.Orientation=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'OriginalRawFileName')
        Camera.OriginalRawFileName=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'OriginalRawFileData')
        Camera.OriginalRawFileData=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'PhotometricInterpretation')
        Camera.PhotometricInterpretation=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'PlanarConfiguration')
        Camera.PlanarConfiguration=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'ResolutionUnit')
        Camera.ResolutionUnit=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'RowsPerStrip')
        Camera.RowsPerStrip=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'SamplesPerPixel')
        Camera.SamplesPerPixel=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'ShadowScale')
        Camera.ShadowScale=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Software')
        Camera.Software=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'StripByteCounts')
        Camera.StripByteCounts=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'StripOffsets')
        Camera.StripOffsets=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'SubIFDs')
        Camera.SubIFDs=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Thresholding')
        Camera.Thresholding=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'TileByteCounts')
        Camera.TileByteCounts=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'TileLength')
        Camera.TileLength=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'TileOffsets')
        Camera.TileOffsets=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'TileWidth')
        Camera.TileWidth=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'UniqueCameraModel')
        Camera.UniqueCameraModel=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'WhiteLevel')
        Camera.WhiteLevel=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'Width')
        Camera.Width=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'XMP')
        Camera.XMP=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'XResolution')
        Camera.XResolution=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'YResolution')
        Camera.YResolution=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'YCbCrCoefficients')
        Camera.YCbCrCoefficients=getfield(Info,fieldstring);
    elseif strcmp(fieldstring,'UnknownTags')
        UnknownTags=getfield(Info,fieldstring);
        for m=1:length(UnknownTags)
            switch UnknownTags(m).ID
                case 33421
                    Camera.CFARepeatPatternDimension=UnknownTags(m).Value;
                case 33422
                    Camera.CFAPatternValue=UnknownTags(m).Value;
                case 50931
                    Camera.CameraCalibrationSignature=UnknownTags(m).Value;
                case 50932
                    Camera.ProfileCalibrationSignature=UnknownTags(m).Value;
                case 50933
                    Camera.ExtraCameraProfiles=UnknownTags(m).Value;
                case 50940
                    Camera.ProfileToneCurve=UnknownTags(m).Value;
                case 50964
                    Camera.ForwardMatrix1=UnknownTags(m).Value;
                case 50965
                    Camera.ForwardMatrix2=UnknownTags(m).Value;
                case 50936
                    Camera.ProfileName=UnknownTags(m).Value;
                case 50937
                    Camera.ProfileHueSatMapDims=UnknownTags(m).Value;
                case 50938
                    Camera.ProfileHueSatMapData1=UnknownTags(m).Value;
                case 50939
                    Camera.ProfileHueSatMapData2=UnknownTags(m).Value;
                case 50941
                    Camera.ProfileEmbedPolicy=UnknownTags(m).Value;
                case 50942
                    Camera.ProfileCopyright=UnknownTags(m).Value;
                case 50966
                    Camera.PreviewApplicationName=UnknownTags(m).Value;
                case 50967
                    Camera.PreviewApplicationVersion=UnknownTags(m).Value;
                case 50973
                    Camera.OriginalRawFileDigest=UnknownTags(m).Value;
                case 50969
                    Camera.PreviewSettingsDigest=UnknownTags(m).Value;
                case 50970
                    Camera.PreviewColorSpace=UnknownTags(m).Value;
                case 50971
                    Camera.PreviewDateTime=UnknownTags(m).Value;
                case 50972
                    Camera.RawImageDigest=UnknownTags(m).Value;
                case 50981
                    Camera.ProfileLookTableDims=UnknownTags(m).Value;
                case 50982
                    Camera.ProfileLookTableData=UnknownTags(m).Value;
                case 51008
                    Camera.OpcodeList1=UnknownTags(m).Value;
                case 51009
                    Camera.OpcodeList2=UnknownTags(m).Value;
                case 51022
                    Camera.OpcodeList3=UnknownTags(m).Value;
                case 51041
                    Camera.NoiseProfile=UnknownTags(m).Value;
                case 37393
                    Unknown_37393=UnknownTags(m);
                    save('rawcamera.mat','Unknown_37393','-append');
                case 51002
                    Unknown_51002=UnknownTags(m);
                    save('rawcamera.mat','Unknown_51002','-append');
                case 51114
                    Unknown_51114=UnknownTags(m);
                    save('rawcamera.mat','Unknown_51114','-append');
                otherwise
                    disp('-----UnknownTags-------');
                    XxxxUnknown=UnknownTags(m);
                    save('rawcamera.mat','XxxxUnknown','-append');
                    INTERRUPT
            end
        end
    elseif strcmp(fieldstring,'Copyright')
        Camera.Copyright=getfield(Info,fieldstring);
    else
        XxxxNewTag=getfield(Info,fieldstring);
        XxxxNewFieldstring=fieldstring;
        disp('-------New Tags found--------');
        save('rawcamera.mat','XxxxNewFieldstring','XxxxNewTag','-append');
        INTERRUPT
    end
end
save('rawcamera.mat','Camera','-append');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
