%--------------------------------------------------------------------------
function CFA=MatDeltaCalibration(CFA)
%--------------------------------------------------------------------------
load('rawcamera.mat','Camera');
CFA=double(CFA);
if isfield(Camera,'BlackLevelDeltaV')
    disp('-----Found BlackLevelDeltaV------');
    row1=Camera.ActiveArea(1)+1;col1=Camera.ActiveArea(2)+1;
    row2=Camera.ActiveArea(3);col2=Camera.ActiveArea(4);
    CFA(row1:row2,col1:col2)=CFA(row1:row2,col1:col2)...
        -repmat(Camera.BlackLevelDeltaV',1,col2-col1+1);
    CFA=max(CFA,0);
    BlackLevelDeltaV=Camera.BlackLevelDeltaV;
    save('rawdecode.mat','BlackLevelDeltaV','-append');
end
if isfield(Camera,'BlackLevelDeltaH')
    disp('-----Found BlackLevelDeltaV------');
    row1=Camera.ActiveArea(1)+1;col1=Camera.ActiveArea(2)+1;
    row2=Camera.ActiveArea(3);col2=Camera.ActiveArea(4);
    CFA(row1:row2,col1:col2)=CFA(row1:row2,col1:col2)...
        -repmat(Camera.BlackLevelDeltaH,col2-col1+1,1);
    CFA=max(CFA,0);
    BlackLevelDeltaH=Camera.BlackLevelDeltaH;
    save('rawdecode.mat','BlackLevelDeltaH','-append');
end
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
