%--------------------------------------------------------------------------
% Draw Image Histogram, ImageRgb(3,:) => 0.0-1.0 
%--------------------------------------------------------------------------
function HistData=MatImageHist(ImageRgb,BitNums,TitleString,mode)
%--------------------------------------------------------------------------
load('rawconfig.mat','FigSequence');
drawcolor=char('r','g','b');
drawtitle=char('RED','GREEN','BLUE');
ImageRgb=max(ImageRgb,0.0);ImageRgb=min(ImageRgb,1.0);
ImageRgb=round(ImageRgb*(2^BitNums-1))+1;
minValue=1;maxValue=2^BitNums;
color=['r','g','b'];
for n=1:3
    HistData(n,:)=hist(ImageRgb(n,:),minValue:maxValue);
    figure(FigSequence);
    FigSequence=FigSequence+1;
    if mode~=0
        bar(minValue:maxValue,...
            HistData(n,minValue:maxValue),1.0,color(n));
    else
        bar(minValue+1:maxValue-1,...
            HistData(n,minValue+1:maxValue-1),1.0,color(n));
    end
    grid on
    title(TitleString);
end
save('rawconfig.mat','FigSequence','-append');
%--------------------------------------------------------------------------
end
%-------------------- Function Ending -------------------------------------

