%--------------------------------------------------------------------------
% ProPoto R,G,B => H,U,V
% ImageRgb(:,:,3) R-1,G-2,B-3 => ImageHsv(:,:,3) H-1,S-2,V-3
%--------------------------------------------------------------------------
function ImageHsv=MatRgb2Hsv(ImageRgb)
%--------------------------------------------------------------------------
% function ImageHsv=MatRgb2Hsv()
% clear all;
% ImageRgb=[...
%     1, 0, 0.45, 1.0,  0.71, 0.275, 0.5, 0.5, 0,   1.25;...
%     1, 0, 0.45, 0.35, 0.71, 1.0,   0.5, 0,   0.5, 0.5;...
%     1, 0, 0.45, 0.35, 1.0,  0.275, 0,   0.5, 0.5  1.15];
%--------------------------------------------------------------------------
ImageRgb=max(ImageRgb,0);ImageRgb=min(ImageRgb,1.0);
V=max(ImageRgb);C=V-min(ImageRgb);
R=ImageRgb(1,:);G=ImageRgb(2,:);B=ImageRgb(3,:);clear ImageRgb;
S=(C./(V.*double(V~=0)+double(V==0))).*double(V~=0);
Cdiv=C.*double(C~=0)+double(C==0);
H=60.*(0.0*double(C==0)...
    +mod((G-B)./Cdiv,6).*double(C~=0&V==R)...
    +((B-R)./Cdiv+2).*double(C~=0&V~=R&V==G)...
    +((R-G)./Cdiv+4).*double(C~=0&V~=R&V~=G&V==B));
clear R;clear G;clear B;clear Cdiv;clear C;
H=mod(H,360);S=max(S,0);S=min(S,1.0);V=max(V,0);V=min(V,1.0);
ImageHsv=[H;S;V];
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
