%--------------------------------------------------------------------------
% Bayer Extract Function
%--------------------------------------------------------------------------
function Photo=RawBayerExtraction(CFA)
%--------------------------------------------------------------------------
load('rawconfig.mat','BayerCfaSave',...
    'BayerInterpolate','MatlabBayerInterp');
disp('2');
CFA=MatLinearCalibration(CFA);
CFA=MatDeltaCalibration(CFA);

disp('1');
if BayerCfaSave~=0 || BayerInterpolate==0 || MatlabBayerInterp==0
    Photo=MatBayerDecode(CFA);
end
if BayerInterpolate~=0 && MatlabBayerInterp~=0
    Photo=MatBayerInterpolate(CFA);
end

disp('0');
[PhotoHeight,PhotoWidth,PhotoColor]=size(Photo);
save('rawdecode.mat','PhotoWidth','PhotoHeight','-append');
%--------------------------------------------------------------------------
end
%--------------------------------------------------------------------------
